#!/bin/bash

echo  ""
cat /proc/cpuinfo | grep "model name"
echo  ""
uname -a
echo  ""
gcc --version
#gcc run to memory - please :)
cp ./normal.c.bckp ./normal.c
gcc normal.c -o normal

max=4
sum_cn=0
sum_ce=0
sum_cng=0
sum_ceg=0
sum_ca=0
sum_rn=0
sum_re=0
sum_ra=0
sum_rng=0
sum_reg=0


#count of iteration tests
if [ "$#" -gt "0" ]; then
  max=$(($1 + 0))
fi
#go
o=($@)
c=$#
steps=$(($max * 10 * (c - 1)))
step=0
function progress {
  echo -ne "Step/Steps: ${step}/${steps}  \r"
  step=$(($step + 1))
}
progress
for ((y=1; y < c; y++)); do
  cp ./normal.c.bckp ./normal.c
  cp ./normalext.c.bckp ./normalext.c
  cp ./assign.c.bckp ./assign.c
  cp ./normalglb.c.bckp ./normalglb.c
  cp ./normalextglb.c.bckp ./normalextglb.c  

  sum_cn=0
  sum_ce=0
  sum_cng=0
  sum_ceg=0
  sum_ca=0
  sum_rn=0
  sum_re=0
  sum_ra=0
  sum_rng=0
  sum_reg=0

  for ((x=0; x < ${max}; x++)); do
    echo ' ' >> normal.c
    progress
    t_tmps="$(date +%s.%N)"
    gcc ${o[$y]} normal.c -o normal
    t_tmpe="$(date +%s.%N)"
    a=`echo "scale=6; ${t_tmpe} - ${t_tmps}" | bc`
    sleep 1
    progress
    t_tmps="$(date +%s.%N)"
    ./normal 18123 > /dev/null
    t_tmpe="$(date +%s.%N)"
    b=`echo "scale=6; ${t_tmpe} - ${t_tmps}" | bc`

    sum_cn=`echo "scale=8; ${sum_cn} + $a" | bc`
    sum_rn=`echo "scale=8; ${sum_rn} + $b" | bc`
  done

  for ((x=0; x < ${max}; x++)); do
    echo ' ' >> normalext.c
    progress
    t_tmps="$(date +%s.%N)"
    gcc ${o[$y]} normalext.c -o normalext
    t_tmpe="$(date +%s.%N)"
    a=`echo "scale=6; ${t_tmpe} - ${t_tmps}" | bc`
    sleep 1
    progress
    t_tmps="$(date +%s.%N)"
    ./normalext 18123 > /dev/null
    t_tmpe="$(date +%s.%N)"
    b=`echo "scale=6; ${t_tmpe} - ${t_tmps}" | bc`

    sum_ce=`echo "scale=8; ${sum_ce} + $a" | bc`
    sum_re=`echo "scale=8; ${sum_re} + $b" | bc`
  done

  for ((x=0; x < ${max}; x++)); do
    echo ' ' >> normalglb.c
    progress
    t_tmps="$(date +%s.%N)"
    gcc ${o[$y]} normalglb.c -o normalglb
    t_tmpe="$(date +%s.%N)"
    a=`echo "scale=6; ${t_tmpe} - ${t_tmps}" | bc`
    sleep 1
    progress
    t_tmps="$(date +%s.%N)"
    ./normalglb 18123 > /dev/null
    t_tmpe="$(date +%s.%N)"
    b=`echo "scale=6; ${t_tmpe} - ${t_tmps}" | bc`

    sum_cng=`echo "scale=8; ${sum_cng} + $a" | bc`
    sum_rng=`echo "scale=8; ${sum_rng} + $b" | bc`
  done

  for ((x=0; x < ${max}; x++)); do
    echo ' ' >> normalextglb.c
    progress
    t_tmps="$(date +%s.%N)"
    gcc ${o[$y]} normalextglb.c -o normalextglb
    t_tmpe="$(date +%s.%N)"
    a=`echo "scale=6; ${t_tmpe} - ${t_tmps}" | bc`
    sleep 1
    progress
    t_tmps="$(date +%s.%N)"
    ./normalextglb 18123 > /dev/null
    t_tmpe="$(date +%s.%N)"
    b=`echo "scale=6; ${t_tmpe} - ${t_tmps}" | bc`

    sum_ceg=`echo "scale=8; ${sum_ceg} + $a" | bc`
    sum_reg=`echo "scale=8; ${sum_reg} + $b" | bc`
  done

  for ((x=0; x < ${max}; x++)); do
    echo ' ' >> assign.c
    progress
    t_tmps="$(date +%s.%N)"
    gcc ${o[$y]} assign.c -o assign 
    t_tmpe="$(date +%s.%N)"
    a=`echo "scale=6; ${t_tmpe} - ${t_tmps}" | bc`
    sleep 1
    progress
    t_tmps="$(date +%s.%N)"
    ./assign 18123 > /dev/null
    t_tmpe="$(date +%s.%N)"
    b=`echo "scale=6; ${t_tmpe} - ${t_tmps}" | bc`

    sum_ca=`echo "scale=8; ${sum_ca} + $a" | bc`
    sum_ra=`echo "scale=8; ${sum_ra} + $b" | bc`
  done

  avg_cn=`echo "scale=6; ${sum_cn} / ${max}" | bc`
  avg_rn=`echo "scale=6; ${sum_rn} / ${max}" | bc`
  avg_ce=`echo "scale=6; ${sum_ce} / ${max}" | bc`
  avg_re=`echo "scale=6; ${sum_re} / ${max}" | bc`
  avg_cng=`echo "scale=6; ${sum_cng} / ${max}" | bc`
  avg_rng=`echo "scale=6; ${sum_rng} / ${max}" | bc`
  avg_ceg=`echo "scale=6; ${sum_ceg} / ${max}" | bc`
  avg_reg=`echo "scale=6; ${sum_reg} / ${max}" | bc`
  avg_ca=`echo "scale=6; ${sum_ca} / ${max}" | bc`
  avg_ra=`echo "scale=6; ${sum_ra} / ${max}" | bc`

  echo -e "\nResults, options '${o[$y]}':"
  printf " Global Normal {},      compile: %10.6f; run: %8.6f\n" ${avg_cng} ${avg_rng}
  printf " Global Normalext {[]}, compile: %10.6f; run: %8.6f\n" ${avg_ceg} ${avg_reg}
  printf " Normal {},             compile: %10.6f; run: %8.6f\n" ${avg_cn} ${avg_rn}
  printf " Normalext {[]},        compile: %10.6f; run: %8.6f\n" ${avg_ce} ${avg_re}
  printf " Assign [],             compile: %10.6f; run: %8.6f\n" ${avg_ca} ${avg_ra}
  echo "Binary file size:" 
  ls -l ./normalglb
  ls -l ./normalextglb
  ls -l ./normal
  ls -l ./normalext
  ls -l ./assign
done

if [ "$#" -lt "2" ]; then
  echo "1st. param is count of test iteration (recomended max 16) and next parameters compiler options"
  echo "Exapmple: ./text bash 8 -O0 -O3 = 8 statistic tests for two compilere optimize level"
fi
echo  ""



